//Logic calls back to defaultSettings on install, setting must be listed to appear on menu
const defaultSettings = {
		framesPerSecond: 0,
		autoSave: 0,
		gamePopups: 0,
		autoMagic: 0,
		autoTrade: 0,
    clickBigCookie: 0,
    clickFortunes: 0,
    clickGoldenCookies: 0,
    harvestLumps: 0,
    petKrumblor: 0,
    popWrinklers: 0,
		autoResearch: 0,
		gardenSpeed: 0,
		bankSpeed: 0,
		buildingPrice: 0,
		infinityFrenzy: 0,
		resetBuffs: 0,
		steamAchieves: 0,
};
//Menu Buttons and their values
//Buttons are listed in order of code
const settingsKeys = Object.keys(defaultSettings);
const menuDictionary = {
	framesPerSecond: { //Kind of an odd result when using this, not sure if it works /shrug
			name: 'FPS',
			description: 'Set your frames per second.',
			values: {
					0: 'OFF',
					1: '30',
					2: '60',
					3: '90',
					4: '144',
					5: '165'
			}
	},
	autoSave: {
			name: 'Autosave',
			description: 'Disable/Enable autosave.',
			values: {
					0: 'ON',
					1: 'OFF',
			}
	},
	gamePopups: {
			name: 'Popups',
			description: 'Disable/Enable game notification popups',
			values: {
					0: 'ON',
					1: 'OFF',
			}
	},
	autoMagic: {
			name: 'Cast Spells',
			description: 'Cast any selected spell when magic is full.',
			values: {
					0: 'OFF',
					1: 'CONJURE BAKED GOODS',
					2: 'HAND OF FATE',
					3: 'STRETCH TIME',
					4: 'SPONTANEOUS EDIFICE',
					5: `HAGGLER'S CHARM`,
					6: 'SUMMON CRAFTY PIXIES',
					7: `GAMBLER'S FEVER DREAM`,
					8: 'RESURRECT ABOMINATION',
					9: 'DIMINISH INEPTITUDE'
			} //Some of these spells are useless ngl
	},
	autoTrade: {
			name: 'Stock Trading',
			description: 'Automatic stock trading algorithm designed around profits. (Always get brokers!)',
			values: {
					0: 'OFF',
					1: 'ON'
			} // needs work
	},
	clickBigCookie: {
			name: 'Big Cookie',
			description: 'Click the big cookie. Set to a higher number if lagging.',
			values: {
					0: 'OFF',
					1: '1ms',
					2: '10ms',
					3: '30ms',
					4: '60ms',
			}
	},
	clickFortunes: {
			name: 'Fortunes',
			description: 'Click Fortune news appearances.',
			values: {
					0: 'OFF',
					1: 'ON'
			}
	},
	clickGoldenCookies: {
			name: 'Golden Cookies',
			description: 'Click Golden Cookies and Reindeer as they appear.',
			values: {
					0: 'OFF',
					1: 'EXCEPT WRATH',
					2: 'ALL'
			}
	},
    harvestLumps: {
        name: 'Sugarlumps',
        description: 'Harvest the next Sugarlump when ripe.',
        values: {
            0: 'OFF',
            1: 'ON'
        }
    },
    petKrumblor: {
        name: 'Pet Krumblor',
        description: 'Pet Krumblor to unlock his drops.',
        values: {
            0: 'OFF',
            1: 'ON'
        }
    },
		popWrinklers: {
        name: 'Pop wrinklers',
        description: 'destroys wrinklers when certain conditions are met',
        values: {
            0: 'OFF',
            1: 'WHEN FULL',
            2: 'EXCEPT GOLDEN',
            3: 'AFTER EATING',
            4: 'IMMEDIATELY'
        }
    },
		autoResearch: {
				name: 'Research',
				description: 'Avert the Grandmapocalypse.',
				values: {
						0: 'OFF',
						1: 'ON'
				}
		},
		gardenSpeed: {
        name: 'Garden Speed',
        description: 'Change the garden tick rate.',
        values: {
            0: 'OFF',
						1: '1s',
						2: '5s',
						3: '10s',
						4: '30s',
						5: '1m',
						6: '2m',
        }
    },
		bankSpeed: {
        name: 'Bank Speed',
        description: 'Change the bank tick rate.',
        values: {
            0: 'OFF',
						1: '1s',
						2: '3s',
						3: '5s',
						4: '10s',
						5: '30s',
        }
    },
		buildingPrice: {
        name: 'Building Price',
        description: 'Same function as no building price increase mod.',
        values: {
            0: 'OFF',
            1: 'ON',
        }
    },
		infinityFrenzy: {
        name: 'Infinity Frenzy',
        description: 'Same function as infinity frenzy mod.',
        values: {
            0: 'OFF',
            1: 'ON',
        }
    },
		resetBuffs: {
        name: 'Reset Buffs',
        description: 	`Reset buffs. Click off and back on to reset again.`,
        values: {
            0: 'OFF',
            1: 'BUFFS RESET',
        }
    },
		steamAchieves: {
        name: 'Steam Achievements',
        description: 	`Toggle Steam Achievements`,
        values: {
            0: 'Enabled',
            1: 'Disabled',
        }
    },
};

//Check for CCSE
//Install if none found
if (typeof CCSE == 'undefined')
	Game.LoadMod('https://klattmose.github.io/CookieClicker/CCSE.js');

//Function
const AP = {
    init() {
        const AP = this;
        const GameUpdateMenu = Game.UpdateMenu;
				garden = Game.Objects['Farm'].minigame; //Reference for Garden minigame
				bank = Game.Objects['Bank'].minigame; //Reference for Bank minigame
        Game.UpdateMenu = function() {
            GameUpdateMenu();
            AP.addMenu();
        }
				//Tick Now buttons
					if (Game.Objects['Farm'].minigameLoaded) {
	    		let gsStr = '<div style="display: block;font-size:13px;">' + loc('Tick Garden Now');
					gsStr += '<p> <div class="bankButton bankButtonSell" id="gardenTickNow">Click</div></div>';
			    l('gardenTools').insertAdjacentHTML('afterend', gsStr);
			    AddEvent(l('gardenTickNow'),'click',function(){
			        garden.nextStep = Date.now();
			    });
				}
					if (Game.Objects['Bank'].minigameLoaded) {
			  	let bsStr = '<div style="display:block;">' + loc('Tick Market Now');
					bsStr += '<p> <div class="bankButton bankButtonSell" id="marketTickNow">Click</div></div>';
	        l('bankHeader').insertAdjacentHTML('beforeend', bsStr);
					AddEvent(l('marketTickNow'),'click',function(){
	      		Game.Objects['Bank'].minigame.secondsPerTick =-1;
			    });
				}
				/*if (Game.Objects['Bank'].minigameLoaded) {//Not working
					let slStr = '<div style="display:block;">';
					slStr += '<p> <div class="bankButton bankButtonSell" id="sugarTickNow">Click</div></a>';
					l('lumpsAmount').insertAdjacentHTML('beforeend', slStr);
					AddEvent(l('sugarTickNow'),'click',function(){
					Game.Objects['Bank'].minigame.secondsPerTick =-1;
					});
				}*/

		//Hook Registery
        Game.registerHook('draw', this.onDraw.bind(this));
        Game.registerHook('logic', this.onLogic.bind(this));
				Game.registerHook('reincarnate', this.onAscend.bind(this));
				Game.registerHook('click', this.onClick.bind(this));
        Game.registerHook('reset', this.onReset.bind(this));

		//Startup notification
				Game.Notify(`Automation+ Active!`,'Version 2.5',[25,7], 6);
    },
    save() { //Save defaultSettings and stockData to selected values
        const saveData = Object.fromEntries(Object.entries(this.settings).filter(([key]) => settingsKeys.includes(key)));
        const {stockData} = this;
        return JSON.stringify({saveData, stockData});
    },
    load(str) {//Where to save data
        if (str !== undefined && str.length > 0) {
            const {saveData, stockData} = JSON.parse(str);
            this.stockData = stockData ?? {};
            this.settings = {
                ...this.settings,
                ...saveData
            };
        }
        this.setDragonDrops();//Reset dragon drops check
    },
    settings: defaultSettings,
    stockData: {},
    dragonDrops: [],
    handlingBigCookie: false,
    addMenu() {
        if (Game.onMenu === 'prefs') { //Build preferences menu
            const newBlock = this.createMenu();
            const menu = l('menu');
            const [titleSection] = l('menu').getElementsByClassName('section');
            l('menu').insertBefore(newBlock, titleSection.nextSibling);
        }
    },
		createMenu() {//Define menu location and settings
        const block = document.createElement('div');
        block.className = 'block';
        block.style = 'padding:0px;margin:8px 4px;';


        const subsection = document.createElement('div');
        subsection.className = 'subsection';
        subsection.style = 'padding:0px';
        block.appendChild(subsection);

        const title = document.createElement('div');
        title.className = 'title';
        title.innerHTML = `Automation+`;
        subsection.appendChild(title);

        settingsKeys.forEach(key => { //Create dictionary buttons with their values
            subsection.appendChild(this.createMenuListing(key));
        });

				const label2 = document.createElement('label');
        label2.className = 'label';
				label2.style = `font-family:'Merriweather', Georgia,serif;font-size:11px;padding:16px;position:center;bottom:2px;right:2px;`
        label2.innerHTML = '<label>'+loc(`Steam Achievement Status: ${Steam.allowSteamAchievs ? "Enabled" : "Disabled"} \n‎ \n`)+'</label><br></br>'
        subsection.appendChild(label2);

        return block;
    },
    createMenuListing(id) { //Menu button function
        const AP = this; //AP = Automation+
        const {settings} = AP;
        const value = settings[id];
        const {name, description, values} = menuDictionary[id];

        const listing = document.createElement('div');
        listing.className = 'listing';

        const a = document.createElement('a');
        a.className = `smallFancyButton prefButton option${value > 0 ? '' : ' off'}`;//Button style
        a.innerText = `${name} \n ${values[value]}`;
        a.onclick = function() {
					//Added Button Variables
            const newValue = (value + 1) % Object.entries(values).length;
						if (id === 'autoTrade' && newValue === 0) {
								AP.stockData = {};
						}
						//IF Buttons function here, binded function checks for ascension
						if (id === 'infinityFrenzy' && newValue === 1) {
							Game.gainBuff('frenzy',Infinity,7);
						}
						if (id === 'infinityFrenzy' && newValue === 0) {
							if (Game.buffs["Frenzy"]) {
								Game.buffs["Frenzy"].time = 0
							}
						}

            settings[id] = newValue;
            PlaySound('snd/tick.mp3');
            Game.UpdateMenu();
				},

        listing.appendChild(a);

        const label = document.createElement('label');
        label.innerText = `(${description})`;
        listing.appendChild(label);

				return listing;

    },
    setDragonDrops() { //Look for drops and check if they're ready
        Math.seedrandom(Game.seed+'/dragonTime');
        const drops = ['Dragon scale', 'Dragon claw', 'Dragon fang', 'Dragon teddy bear'];
        const shuffled = shuffle(drops);
        Math.seedrandom();
        this.dragonDrops = shuffled;
    },
    onDraw() { //Bind for buttons using draw hook
        const {
						framesPerSecond,
						autoTrade,
            clickFortunes,
            clickGoldenCookies,
            harvestLumps,
            popWrinklers,
						autoResearch,
						bankSpeed,
						gardenSpeed,
						buildingPrice
        } = this.settings;
				this.handleFramesPerSecond(framesPerSecond);
				this.handleStonks(autoTrade)
        this.handleFortunes(clickFortunes);
        this.handleShimmers(clickGoldenCookies);
        this.handleLumps(harvestLumps);
        this.handleWrinklers(popWrinklers);
				this.handleAutoResearch(autoResearch);
				this.handleBankSpeed(bankSpeed);
				this.handleGardenSpeed(gardenSpeed);
				this.handleBuildingPrice(buildingPrice);
    },
    onLogic() { //Bind for buttons using logic hook
        const {
						autoMagic,
            clickBigCookie,
            petKrumblor
        } = this.settings;
				    this.handleMagic(autoMagic);
        if (this.handlingBigCookie !== !!clickBigCookie) { //Check if clicking is stuck
            this.handlingBigCookie = !this.handlingBigCookie;
            if (this.handlingBigCookie) {
                this.handleBigCookie();
            } else {
                clearTimeout(this.bigCookieTimeout);
            }
        }
        this.handleKrumblor(petKrumblor);
    },
		onAscend() { //Bind for buttons using ascend hook
			const {
				infinityFrenzy
			} = this.settings;
			this.handleInfinityFrenzy(infinityFrenzy);
		},
		onClick() { //Bind for buttons using click hook
			const {
			autoSave,
			gamePopups,
			resetBuffs,
			steamAchieves
			} = this.settings;
			this.handleAutoSave(autoSave);
			this.handleGamePopups(gamePopups);
			this.handleResetBuffs(resetBuffs);
			this.handleSteamAchieves(steamAchieves);
		},
    onReset() { //Reset functions
        this.stockData = {};
        this.setDragonDrops();
    },
		handleFramesPerSecond(setting) {//Frames function
			if (setting === 0) {
				return;
			}
			if (setting === 1) {
				Game.FPS = 30;
			}
			if (setting === 2) {
				Game.FPS = 60;
			}
			if (setting === 3) {
				Game.FPS = 90;
			}
			if (setting === 4) {
				Game.FPS = 144;
			}
			if (setting === 5) {
				Game.FPS = 165;
			}
		},
		handleAutoSave(setting){ //Autosave function
			if (setting === 0) {
				Game.prefs["autosave"] = 1;
			}
			if (setting === 1) {
				Game.prefs["autosave"] = 0;
			}
		},
		handleGamePopups(setting){//Popups Function
			if (setting === 0) {
				Game.popups =1;
				return;
			}
			if (setting === 1) {
				Game.popups =0;
				return;
			}
		},
		handleMagic(setting) { //Autocast function
        if (setting === 0) {
            return;
        }
        const {minigame} = Game.Objects['Wizard tower'];
        if (minigame !== undefined && minigame.magic === minigame.magicM) {//Find spell and run it when bar is full
            const spellName = menuDictionary.autoMagic.values[setting].toLowerCase();
            minigame.castSpell(minigame.spells[spellName]);
        }
    },
		handleStonks(setting) {//Stock trading function
        if (setting === 0) {
            return;
        }
        if (!Game.isMinigameReady(Game.Objects.Bank)) {
            return;
        }
        const {minigame} = Game.Objects.Bank;
        if (minigame.lastTickDrawn === this.lastTickChecked) {
            return;
        }

        const {stockData} = this;
        minigame.goodsById.forEach(good => {
            if (!good.active) {
                return;
            }
            const abbr = good.symbol;
            const data = stockData[abbr] ?? {};
            const value = good.val;
            if (good.stock === 0) {
                data.sellFloor = undefined;
                if (value < (data.price ?? Infinity)) {
                    data.price = value;
                }
                if (value === 1 || (value < minigame.getRestingVal(good.id) && value >= data.price * 1.1)) {
                    minigame.buyGood(good.id, 10000); // max button uses this value
                    data.sellFloor = value * (1 + 0.2 * .95 ** minigame.brokers);
                }
            } else if (value > (data.price ?? -Infinity)) {
                data.price = value;
            } else if (value <= ((data.price - good.prev) * 0.9) + good.prev
                && value > (data.sellFloor ?? (good.prev * (1 + 0.2 * .95 ** minigame.brokers)))) {
                minigame.sellGood(good.id, 10000); // all button uses this value
            }
            stockData[abbr] = data;
        });

        this.lastTickChecked = minigame.lastTickDrawn;
    },
    handleBigCookie(setting) {//Autoclicker
        if (this.settings.clickBigCookie) {
            Game.ClickCookie();
        }
        this.bigCookieTimeout = setTimeout(this.handleBigCookie.bind(this), setting); //Set timeout to setting
    },
    handleFortunes(setting) { //Auto fortune clicker
        if (setting === 0) {
            return;
        }
        if (Game.TickerEffect.type === 'fortune') {
            Game.tickerL.click();
        }
    },
    handleShimmers(setting) { //Auto golden cookies
        if (setting === 0) {
            return;
        }
        Game.shimmers.forEach(shimmer => {
            if (setting === 2 || shimmer?.wrath !== 1) {
                shimmer.l.click();
            }
        });
    },
    handleLumps(setting) {//Harvest lumps function
        if (setting === 0) {
            return;
        }
        const age = Date.now() - Game.lumpT;
        if (age > Game.lumpRipeAge) {
            Game.clickLump();
        }
    },
		handleWrinklers(setting) {
        if (setting === 0) {
            return;
        }
        const maxWrinklers = Game.getWrinklersMax();
        if (setting === 1 && Game.wrinklers.slice(0, maxWrinklers).find(wrinkler => wrinkler.phase !== 2)) {
            return;
        }

        let fattestWrinkler = {sucked: 0};
        Game.wrinklers.slice(0, maxWrinklers).forEach(wrinkler => {
            if (setting === 4 || (setting === 3 && wrinkler.phase === 2) || (setting === 2 && wrinkler.type === 0)) {
                wrinkler.hp = 0;
            } else if (wrinkler.type === 0 && wrinkler.sucked > fattestWrinkler.sucked) {
                fattestWrinkler = wrinkler;
            }
        });
        fattestWrinkler.hp = 0;
    },
		handleKrumblor(setting) {//Pet krumblor function
        if (setting === 0) {
            return;
        }
        if (Game.specialTab !== 'dragon' || !Game.Has('Pet the dragon') || Game.dragonLevel < 8 || this.dragonDrops.every(drop => Game.Has(drop))) {
            return;
        }
        const currentDrop = this.dragonDrops[Math.floor((new Date().getMinutes() / 60) * this.dragonDrops.length)];
        if (Game.Upgrades[currentDrop].unlocked === 1) {
            return;
        }

        Game.ClickSpecialPic();
    },
		handleAutoResearch(setting) {//Auto research function
			let holdPledge = false;
			if (setting === 0) {
					return;
			}
					if (!(holdPledge && setting === 1) && Game.UpgradesInStore.find((upgrade) => upgrade.name === "Elder Pledge")) Game.Upgrades["Elder Pledge"].buy();
					Game.Upgrades[Game.UpgradesInStore.find((upgrade) => upgrade.pool === "tech" || upgrade.name === "Sacrificial rolling pins")?.name]?.buy(1);
					if (Game.elderWrath !== 0) return;
		},
		handleGardenSpeed(setting) {//Garden speed function
		garden = Game.Objects['Farm'].minigame;
		if (!Game.Objects['Farm'].minigameLoaded) {
			return;
			}
			if (setting === 0) {
				garden.stepT = 400
			}
			if (setting === 1) {
				garden.stepT = 1
			}
			if (setting === 2) {
				garden.stepT = 5
			}
			if (setting === 3) {
				garden.stepT = 10
			}
			if (setting === 4) {
				garden.stepT = 30
			}
			if (setting === 5) {
				garden.stepT = 60
			}
			if (setting === 6) {
				garden.stepT = 120
			}
		},
		handleBankSpeed(setting) {//Bank speed function
			bank = Game.Objects['Bank'].minigame;
			if (!Game.Objects['Bank'].minigameLoaded) {
				return;
			}
			if (setting === 0) {
				bank.secondsPerTick = 60
			}
			if (setting === 1) {
      	bank.secondsPerTick = 1;
			}
			if (setting === 2) {
      	bank.secondsPerTick = 3;
			}
			if (setting === 3) {
      	bank.secondsPerTick = 5;
			}
			if (setting === 4) {
      	bank.secondsPerTick = 10;
			}
			if (setting === 5) {
      	bank.secondsPerTick = 30;
			}
		},
		handleBuildingPrice(setting) {//Building price mod function
			if (setting === 0 && !(Game.priceIncrease = 1.15)) {
				Game.priceIncrease = 1.15;
			}
			if (setting === 1 && !(Game.priceIncrease = 1)) {
				Game.priceIncrease = 1;
			}
		},
		handleInfinityFrenzy(setting) {//Infinity Frenzy mod function
			if (setting === 1 && Game.hasBuff('frenzy')) {
				return;
			}
			if (setting === 1 && !Game.hasBuff('frenzy')) {
				Game.gainBuff('frenzy',Infinity,7);
			}
		},
		handleResetBuffs(setting) {//Reset buffs function
			if (setting === 0) {
				return;
			}
			if (setting ===1) {
				Game.killBuffs();
			}
		},
		handleSteamAchieves(setting) {//Steam achievements function
			if (setting === 0) {
				Steam.allowSteamAchievs = true;
			}
			if (setting === 1) {
				Steam.allowSteamAchievs = false;
			}
		},
}

Game.registerMod('autoplus', AP);
